//General kjv bible support code
var kjv_js_version = 3; //used by tools.html

var kjv_JsFiles = [ //7xJS bible files -- var name | BookIndex (of first book in JS file) | Num books in JS file | filename
  ["kjv_gen",0,5,   "kjv0_gen.js"], 
  ["kjv_jos",5,8,   "kjv1_jos.js"], 
  ["kjv_2ch",13,9,  "kjv2_2ch.js"], 
  ["kjv_isa",22,17, "kjv3_isa.js"], 
  ["kjv_mat",39,5,  "kjv4_mat.js"], 
  ["kjv_rom",44,22, "kjv5_rom.js"],
  ["kjv_aop",66,2,  "kjv6_aop.js"]
];

var kjv_index = [  // col 0 .. 8 (7&8 optional - leave null or undefined if not used)  
  // | 0 = Bible Book #  
  // | 1 = JS File # | 2 = Index info File 
  // | 3 = Fullname | 4= ChapterCount |
  // | 5 = Short Name | 6 = Gateway Name (if audio book -- otherwise "") 
  // | 7 = +Optional - Chapter starts at nn (or leave undefined or != "number") 
  // | 8 = +Optional - Narrow screen Fit Book name (or leave undefined or != "string" to use normal Book name)
  //OLD TESTAMENT
  [1,  0, 0, "Genesis",         50, "Gen", "Gen"],
  [2,  0, 1, "Exodus",          40, "Exo", "Exod"],
  [3,  0, 2, "Leviticus",       27, "Lev", "Lev"],
  [4,  0, 3, "Numbers",         36, "Num", "Num"],
  [5,  0, 4, "Deuteronomy",     34, "Deu", "Deut"],
  [6,  1, 0, "Joshua",          24, "Jos", "Josh"],
  [7,  1, 1, "Judges",          21, "Jdg", "Judg"],
  [8,  1, 2, "Ruth",            4,  "Rth", "Ruth"], 
  [9,  1, 3, "1 Samuel",        31, "1Sa", "1Sam"],
  [10, 1, 4, "2 Samuel",        24, "2Sa", "2Sam"],
  [11, 1, 5, "1 Kings",         22, "1Ki", "1Kgs"],
  [12, 1, 6, "2 Kings",         25, "2Ki", "2Kgs"],
  [13, 1, 7, "1 Chronicles",    29, "1Ch", "1Chr"],
  [14, 2, 0, "2 Chronicles",    36, "2Ch", "2Chr"],
  [15, 2, 1, "Ezra",            10, "Ezr", "Ezra"],
  [16, 2, 2, "Nehemiah",        13, "Neh", "Neh"],
  [17, 2, 3, "Esther",          10, "Est", "Esth"],
  [18, 2, 4, "Job",             42, "Job", "Job"],
  [19, 2, 5, "Psalm",           150,"Psa", "Ps"],
  [20, 2, 6, "Proverbs",        31, "Pro", "Prov"],
  [21, 2, 7, "Ecclesiastes",    12, "Ecc", "Eccl"],
  [22, 2, 8, "Song of Solomon", 8,  "Son", "Song", null, "Song of Sol."],
  [23, 3, 0, "Isaiah",          66, "Isa", "Isa"],
  [24, 3, 1, "Jeremiah",        52, "Jer", "Jer"],
  [25, 3, 2, "Lamentations",    5,  "Lam", "Lam"],
  [26, 3, 3, "Ezekiel",         48, "Eze", "Ezek"],
  [27, 3, 4, "Daniel",          12, "Dan", "Dan"],
  [28, 3, 5, "Hosea",           14, "Hos", "Hos"],
  [29, 3, 6, "Joel",            3,  "Joe", "Joel"],
  [30, 3, 7, "Amos",            9,  "Amo", "Amos"],
  [31, 3, 8, "Obadiah",         1,  "Oba", "Obad"],
  [32, 3, 9, "Jonah",           4,  "Jon", "Jonah"],
  [33, 3, 10, "Micah",          7,  "Mic", "Mic"],
  [34, 3, 11, "Nahum",          3,  "Nah", "Nah"],
  [35, 3, 12, "Habakkuk",       3,  "Hab", "Hab"],
  [36, 3, 13, "Zephaniah",      3,  "Zep", "Zeph"],
  [37, 3, 14, "Haggai",         2,  "Hag", "Hag"],
  [38, 3, 15, "Zechariah",      14, "Zec", "Zech"],
  [39, 3, 16, "Malachi",        4,  "Mal", "Mal"],
  //NEW TESTAMENT
  [40, 4, 0, "Matthew",         28, "Mat", "Matt"],
  [41, 4, 1, "Mark",            16, "Mar", "Mark"],
  [42, 4, 2, "Luke",            24, "Luk", "Luke"],
  [43, 4, 3, "John",            21, "Joh", "John"],
  [44, 4, 4, "Acts",            28, "Act", "Acts"],
  [45, 5, 0, "Romans",          16, "Rom", "Rom"],
  [46, 5, 1, "1 Corinthians",   16, "1Co", "1Cor"],
  [47, 5, 2, "2 Corinthians",   13, "2Co", "2Cor"],
  [48, 5, 3, "Galatians",       6,  "Gal", "Gal"],
  [49, 5, 4, "Ephesians",       6,  "Eph", "Eph"],
  [50, 5, 5, "Philippians",     4,  "Php", "Phil"],
  [51, 5, 6, "Colossians",      4,  "Col", "Col"],
  [52, 5, 7, "1 Thessalonians", 5,  "1Th", "1Thess"],
  [53, 5, 8, "2 Thessalonians", 3,  "2Th", "2Thess"],
  [54, 5, 9, "1 Timothy",       6,  "1Ti", "1Tim"],
  [55, 5, 10, "2 Timothy",      4,  "2Ti", "2Tim"],
  [56, 5, 11, "Titus",          3,  "Tit", "Titus"],
  [57, 5, 12, "Philemon",       1,  "Phm", "Phlm"],
  [58, 5, 13, "Hebrews",        13, "Heb", "Heb"],
  [59, 5, 14, "James",          5,  "Jam", "Jas"],
  [60, 5, 15, "1 Peter",        5,  "1Pe", "1Pet"],
  [61, 5, 16, "2 Peter",        3,  "2Pe", "2Pet"],
  [62, 5, 17, "1 John",         5,  "1Jo", "1John"],
  [63, 5, 18, "2 John",         1,  "2Jo", "2John"],
  [64, 5, 19, "3 John",         1,  "3Jo", "3John"],
  [65, 5, 20, "Jude",           1,  "Jud", "Jude"],
  [66, 5, 21, "Revelation",     22, "Rev", "Rev"],
  //THE APOCRYPHAL
  [67, 6, 0,  "Acts of Peter",  9,  "AoP", "", 32], //starts at ch 33
  [68, 6, 1,  "Targum Jonathan on Genesis",50, "Tar", "", null, "Targum Genesis"]  // 8=narrow fit name    
];



/*
kjvObj global store - initialized below - access data here NOT in above structures

  6xJS File Loading jsStatus eg. "html/kjv/kjv_gen.js"
    0 = Not loaded
    1 = Loading - Standby
    2 = Done: Error Loading (missing file?)
    3 = Done: Loaded OK (ready to access)

  array of JS files and load state
        
    kjvObj.js[jsIdx].name           eg. "html/kjv_gen"
    kjvObj.js[jsIdx].path           eg. "html/kjv/kjv_gen.js"
    kjvObj.js[jsIdx].jsStatus       eg. JS File Load jsStatus - 0(default),1(loading),2(error),3(Loaded)
    kjvObj.js[jsIdx].bkOne          eg. Book index of book #1 eg. 0 kjv_gen file, 5 for kjv_jos etc
    kjvObj.js[jsIdx].bkNum          eg. Num books in this JS file

  array of 66 books info 
       
    kjvObj.book[index].chapter[]    eg. When bible loaded this is filled
    kjvObj.book[index].chapters     eg. Num chapters in book (always available even if JS not loaded)
    kjvObj.book[index].name         eg. Name of bible book
    kjvObj.book[index].name_        eg. Searchable name (lowcase + _)
    kjvObj.book[index].jsFileIdx    eg. Book found in this JS file 
    kjvObj.book[index].verses(ch)   eg, given 1 based chapter - returns verses in ch (0 if JS not loaded) 
*/
var kjvObj = {
              js         : [], 
              book       : [], 
              audioWin   : null, lastAudioBk: -1, lastAudioCh: -1
             };          

function MkSearchable(text) { //Book searchable strings = trim + lowercase + "1 " -> "1_" and Song_of_Solomon
   var i, str = text.trim().toLowerCase();
  
   //expand kjv_index[i][5] book name encoding first
   var ss = str.split(' '); 
   if (ss[0].length == 3) { // might be a encoded name - Rth (for Ruth)
      for (i = 0; i < kjv_index.length; i++) {
        if (ss[0] == kjv_index[i][5].toLowerCase()) {
          str = kjv_index[i][3].toLowerCase() + str.substr(3);   // Now we have a real book name Ruth 1:1
          break;
        }
      } 
   }
  
   if (str.startsWith("1 ")) return "1_" + str.substr(2); 
   else if (str.startsWith("2 ")) return "2_" + str.substr(2); 
   else if (str.startsWith("3 ")) return "3_" + str.substr(2);
   else if (str.startsWith("song of s")) return str.replace(" ","_").replace(" ","_"); 
   else if (str.startsWith("song o")) return str.replace(" ","_"); 
   else if (str.startsWith("acts of p")) return str.replace(" ","_").replace(" ","_");
   else if (str.startsWith("acts o")) return str.replace(" ","_");
   else if (str.startsWith("targum jonathan on g")) return str.replace(" ","_").replace(" ","_").replace(" ","_");
   else if (str.startsWith("targum jonathan o")) return str.replace(" ","_").replace(" ","_");
   else if (str.startsWith("targum j")) return str.replace(" ","_");
   else return str;
} 
function kjvObj_Init() {
  var i;
  
  // JS Files and data
  for (i = 0; i < kjv_JsFiles.length; i++) {
    kjvObj.js[i] = {
      name     :  kjv_JsFiles[i][0],
      bkOne    : kjv_JsFiles[i][1],
      bkNum    : kjv_JsFiles[i][2],
      path     :  ("html/kjv/" +kjv_JsFiles[i][3]),
      jsStatus : 0
    }; 
  }
  
  // Bible books 
  for (i = 0; i < kjv_index.length; i++) {
    
    kjvObj.book[i] = {
      bk       : i,
      chapter  : [],                // eg. book[0].chapter[c][v] = bible text array once html/kjv/kjv_gen.js file loaded
      chapters : kjv_index[i][4],   // eg. book[0].chapters = 50; Num chapters in the book of genesis 
      name     : kjv_index[i][3],   // eg. book[0].name = "Genesis" 
      nameAlt  : (typeof kjv_index[i][8] === "string") ? kjv_index[i][8] : kjv_index[i][3],   // An Alt book name - trimmed to fit narrow screens (see below) 
      name3    : kjv_index[i][5],   // eg. book[0].name3 = "Gen"
      name_    : MkSearchable(kjv_index[i][3]),  // Name used for searching eg. "1 Timothy" -> 1_Timothy"  
      jsFileIdx: kjv_index[i][1],   // eg. book[0].jsFileIdx = 0; -- JS file 0 containing this book
      bg_book  : kjv_index[i][6],   // bg way book names
      vOffset  : (typeof kjv_index[i][7] === "number") ? kjv_index[i][7] : 0,
      verses   : function(ch) {     // Verses in a chapter -- ch is 1 based
                 if (ch >= 1 && ch <= this.chapter.length) return this.chapter[ch-1].length; else return 0; },
      audioURL : function(ch) { 
                 if (this.bg_book == "") return "";
                 else return "https://classic.biblegateway.com/audio/mclean/kjv/"+this.bg_book+"."+ch; },  // ch 1 based
      Audio    : function(ch) {
        if (this.audioURL(ch) == "") {
          alert("No audio available for this book!");
          return;
        }
        kjvObj.audioWin = window.open(this.audioURL(ch),'BGWay',
             'height=160,width=560,left=56,top=25,resizable=yes,scrollbars=yes,titlebar=no,toolbar=no,location=yes,menubar=no,status=no');  
        if (kjvObj.audioWin)
          kjvObj.audioWin.focus();
        kjvObj.lastAudioBk = this.bk;
        kjvObj.lastAudioCh = ch;
        }
    }
    
  }  
  
  
 // alert(kjvObj.book[1].Audio(2));
}
kjvObj_Init();

function findBook_startsWith(text) {  //use MkSearchableStr() before passing a str
   if (!text || text.length == 0) 
     return -1; 
   var i;
   for (i = 0; i < kjvObj.book.length; i++)
     if (kjvObj.book[i].name_.startsWith(text)) 
       return i;
  
   for (i = 0; i < kjvObj.book.length; i++)
     if (kjvObj.book[i].name3.toLocaleLowerCase().startsWith(text)) 
       return i;
   
   return -1;
}
function findBookIdx(text) {  //Same as above but uses MkSearchableStr() lower, trim 
  var ret = [];
  return FindBook(text, ret);
}
function FindBook(text, ret) {  
//
// Given text like "Ge 1:1" return first match in book list
// ret.index = -1  -- -1 if no match found - otherwise index of book match
// ret.book = full book name
// ret.chapter : ret.verse = target ch:verse requested
// rwc1111
 
   var k = -1;                      // Default return
   CopyBkRec(null, ret);            // create ret book obj with defaults
   var text = MkSearchable(text);   // lower, trim, "1 xx" to "1_xx"

   var ss = text.split(' ');        // looking for "gen" or "gen 1" or "gen 1:1" pattern - Not "gen 1 nnn"
  
   if (ss.length == 1 || ss.length == 2) {
      k = findBook_startsWith(ss[0]);
      ret["index"] = k;
      if (k >= 0)
        ret["book"] = kjvObj.book[k].name;  // return full bookname
   }

   // get optional secondary ch:verse param - "1" or "1:2" 
   var badNums = false;
   if (k > -1 && ss.length == 2) 
   {
      var ch = -1;
      var nn = ss[1].split(":");
      if (nn.length == 1 || nn.length == 2) { 
        var n = parseInt(nn[0]);
        if (!isNaN(n) && nn[0].length && nn[0] == nn[0].match(/\d+/)) {  // integer
          var cBookChapters = kjvObj.book[k].chapters;
          n = n - kjvObj.book[k].vOffset;  // we can display a higher range 33-nn  
          if (n > cBookChapters) n = cBookChapters;
          if (n <= 0) n = 1;
          ret["chapter"] = n;
          ch = n;
        } else badNums = true;
      }  else badNums = true; 
     
      if (ch > 0 && nn.length == 2 && !badNums) {
        var n = parseInt(nn[1]);
        if (!isNaN(n) && nn[1].length && nn[1] == nn[1].match(/\d+/)) {
          var cChVerses = kjvObj.book[k].verses(ch);
          if (cChVerses && n > cChVerses) n = cChVerses;
          if (n <= 0) n = 1;
          ret["verse"] = n;
        }
        else badNums = true;
      } 
   }
   if (badNums) 
     return -1;
   return k;
}

function CopyBkRec(bk, ret) {  // bk --> ret | if bk=null just init ret with default book properties
   if (bk === ret)
     return;
   ret.index = -1;     //func returns book index -- ZERO based
   ret.book = "";      //full book name 
   ret.chapter = 1;    // ONE based 
   ret.verse = 1;      // ONE based
   if (bk && bk.index >= 0) {
     ret.index = bk.index;
     ret.book = bk.book;
     ret.chapter = bk.chapter;
     ret.verse = bk.verse;
   }  
}

function Test_kjvBookLoaded(index) { // Sniff out book loaded in our data store
  var jsIdx = kjvObj.book[index].jsFileIdx;
  return (kjvObj.book[index].chapter.length > 0   // Somthing in that book now
       && kjvObj.js[jsIdx].jsStatus === 3);       // Loaded Done flag is set
}
function Test_kjvBookLoaded2(index) { // Sniff out actual JS data file  
   var kjvIdx = kjvObj.book[index].jsFileIdx; 
   var ok;
   switch(kjvIdx) {  //["kjv_gen", "kjv_jos", "kjv_2ch", "kjv_isa", "kjv_mat", "kjv_rom"];
     case 0: ok = (typeof kjv_gen !== 'undefined'); break; 
     case 1: ok = (typeof kjv_jos !== 'undefined'); break;
     case 2: ok = (typeof kjv_2ch !== 'undefined'); break;
     case 3: ok = (typeof kjv_isa !== 'undefined'); break;
     case 4: ok = (typeof kjv_mat !== 'undefined'); break;
     case 5: ok = (typeof kjv_rom !== 'undefined'); break;
     case 6: ok = (typeof kjv_aop !== 'undefined'); break;  
   default: ok = false;
   }
   return ok;
}

function DelayLoadJSFile(bkIndex) {
  var jsIdx  = kjvObj.book[bkIndex].jsFileIdx;
  LoadJSFile(jsIdx);
}
function LoadJSFile(jsIdx) {  // book index -- Return TRUE if already loaded and ready to go
//
// JIT - load 6x JS Bble files when required
// <!-- script type="text/javascript" src="html/kjv/kjv_gen.js" --><!-- /script --> 
//  
  
  var status = kjvObj.js[jsIdx].jsStatus; 
  var bkOne  = kjvObj.js[jsIdx].bkOne; 
  var bkNum  = kjvObj.js[jsIdx].bkNum; 

  // already loaded OK (3) - ready to use!!
  if (status === 3) {
    return true;
  }
  
  // already loading (1) 
  if (status === 1) {
    return false; 
  }

  kjvObj.js[jsIdx].jsStatus = 1; // LOADING

  //==== START_SCRIPT
  var script1 = document.createElement("script");
  script1.type = "text/javascript";
  script1.src = kjvObj.js[jsIdx].path;
  document.head.appendChild(script1);   //was .body.
  //==== END_SCRIPT

  // Error -> onerror event = Missing file? 
  script1.onerror = function() 
  { 
    kjvObj.js[jsIdx].jsStatus = 2; // FAIL
    
    alert("Error loading bible data file: " + this.src +"\nTry downloading the latest '/kjv' folder."); 
  };
  
  // Success -> an OnLoad event
  script1.onload = function() 
  { 
    kjvObj.js[jsIdx].jsStatus = 3; // OK
    
    // Data File Accuracy test
    var ok;
    try {
      switch(jsIdx) {  
        case 0: ok = (kjv_gen.length == bkNum && kjvObj.book[bkOne].name_ == "genesis"); break;  
        case 1: ok = (kjv_jos.length == bkNum && kjvObj.book[bkOne].name_ == "joshua"); break; 
        case 2: ok = (kjv_2ch.length == bkNum && kjvObj.book[bkOne].name_ == "2_chronicles"); break; 
        case 3: ok = (kjv_isa.length == bkNum && kjvObj.book[bkOne].name_ == "isaiah"); break; 
        case 4: ok = (kjv_mat.length == bkNum && kjvObj.book[bkOne].name_ == "matthew"); break; 
        case 5: ok = (kjv_rom.length == bkNum && kjvObj.book[bkOne].name_ == "romans"); break; 
        case 6: ok = (kjv_aop.length == bkNum && kjvObj.book[bkOne].name_ == "acts_of_peter"); break; 
        default: ok = false;
      }
    } catch (e) { ok = false; }
    if (!ok) alert('bible_data_check_error_210 \n\nTry downloading the latest html/kjv/ folder.');
 
    // Assign by Ref into JS data (not a coppy)
    var i;  
    switch(jsIdx) {  
      case 0: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_gen[i]; break;
      case 1: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_jos[i]; break;
      case 2: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_2ch[i]; break;
      case 3: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_isa[i]; break;
      case 4: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_mat[i]; break;
      case 5: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_rom[i]; break;
      case 6: for (i = 0; i < bkNum; i++) kjvObj.book[bkOne+i].chapter = kjv_aop[i]; break;
      default: alert('out_of_range_error_110');
    }
 
  };
  return false;
}
function LoadAllJSFiles() {  // Return TRUE if already loaded and ready to go
  var j, ret = true;
  for (j = 0; j < kjvObj.js.length; j++) {
    
     // No load performed? Load it
     if (kjvObj.js[j].jsStatus === 0)
        LoadJSFile(j);
    
     // Not Loaded? 
     if (kjvObj.js[j].jsStatus !== 3)
       ret = false;
  }

  return ret;  // return true if all files are loaded
}
function GetJSStatus(ss) {  // returns true if ready to go (errors are allowed); returns ss[] array of status
  var j, js, ret = true;
  for (j = 0; j < kjvObj.js.length; j++) {
     js = kjvObj.js[j];
    
     if (ss !== null) {
       if (js.jsStatus == 0)      ss.push(js.path + " (--)" ); 
       else if (js.jsStatus == 1) ss.push(js.path + " (Loading...)" );
       else if (js.jsStatus == 2) ss.push(js.path + " (**Error**)" );
       else if (js.jsStatus == 3) ss.push(js.path + " (OK)" );
     }
    
     // Not Loaded or Error?
     if (js.jsStatus !== 3)
       ret = false;
  } 
  return ret;
}


//============ Search data

var DataList_HTML5Supported = ('options' in document.createElement('datalist'));
function DataList_RemoveItem(dataList, value) {
  if (!DataList_HTML5Supported) return;
  var DL = dataList;
  if (typeof dataList == "string") //an id was sent - we want the obj
    DL = document.getElementById(dataList);
  
  var i;
  for (i = DL.options.length-1; i >= 0; i--) {
    if (DL.options[i].value == value)
      DL.removeChild(DL.options[i]);
  }  
}
function DataList_NewValueTop(dataList, value) {
  if (!DataList_HTML5Supported) return;
  var DL = dataList;
  if (typeof dataList == "string") //an id was sent - we want the obj
    DL = document.getElementById(dataList);
  
  // remove any Existing
  DataList_RemoveItem(DL, value);
  
  // create option using DOM
  /*
  var option = document.createElement('option');
  var optionText = document.createTextNode('Option Text');
  // set option text
  option.appendChild(optionText);
  // and option value
  option.setAttribute('value',value);
  // add the option to the select box
  DL.appendChild(option);
  */
  
  
  //Add new to top
  var option = document.createElement("OPTION");
  option.value = value;
  //option.setAttribute("value", value);
  if (DL.children.length == 0)
    DL.appendChild(option);
  else
    DL.insertBefore(option, DL.children[0]);
  
}
function DataList_AddBooks(dataList) {
  if (!DataList_HTML5Supported) return;
  var DL = dataList;
  if (typeof dataList == "string") //an id was sent - we want the obj
    DL = document.getElementById(dataList);

  var i;
  for (i = 0; i < kjv_index.length; i++) {
    var opt = document.createElement("OPTION");
    opt.setAttribute("value", kjv_index[i][3]);
    DL.appendChild(opt);
  }
}

var _sp = {};  //Search parameters
function FormatNum(num) {
  var str = num.toString();
  if (str.length > 6)
    return str.slice(0,-6) + ',' + str.slice(-6, -3) + ',' + str.slice(-3);
  else if (str.length > 3)
    return str.slice(0, -3) + ',' + str.slice(-3);
  return str;
}
function FormatSrchVerse(bcvStr, str) { // eg. SrchBVC|0|1|11
   var n = str.indexOf("|");            // "Gen 1:2|verse text..."

   return '<span onclick="SrchBlueLinkClick(\''+bcvStr+'\');" class="verseNumberBlue">'
          + str.substr(0, n)    // "Gen 1:2"
          + '</span>&nbsp;&nbsp;' 
          + StyleAllStrongNums(str.substr(n+1));      // Verse Text
}
function MakeSrchBVC(b, c, v) {        // eg. SrchBVC|0|1|11
   return "SrchBVC|"+ b +"|"+ c +"|"+ v;
}
function JumpToSearchBCV(bcvId) {
  var el = document.getElementById(bcvId);
  if (el) {
    event.stopPropagation();
    event.stopImmediatePropagation();
    
    el.scrollIntoView();
    _sp.oTarget.scrollBy(0, -12);
  }
}

function DoMarkUp(str) { 
  var n;
  for (n = 0; n < _sp.filterRE.length; n++) {
    var str = str.replace(_sp.filterRE[n], function(text) {return '<mark>'+text+'</mark>';} );
  }
  return str;
}

function DoSearch_ShowResults() {
  var i, html = [];
  var res = _sp.match;

  //Safe to do <mark> up first -- otherwise we will be marking inside HTML tags
  
  // List Match verses
  var count = 0, bcvStr = "";
  for (i = 0; i < res.length; i++) {
    if (res[i].b < _sp.iFromBk || res[i].b > _sp.iToBk)  // out of view range
      continue;
    
    count++;
    bcvStr = MakeSrchBVC(res[i].b, res[i].c, res[i].v);  // eg. SrchBVC|0|1|11
    
    html.push('<p id="'+bcvStr+'">');
    if (typeof res[i].vstr == "object" && res[i].vstr.length >= 2) {
      html.push(DoMarkUp(res[i].vstr[0]) + '<br>');  // Topic Header
      html.push(FormatSrchVerse(bcvStr, DoMarkUp(res[i].vstr[1]) ));
    }
    else 
      html.push(FormatSrchVerse(bcvStr, DoMarkUp(res[i].vstr) ));   
    html.push("</p>");
  }
  
  //jmpHTML contains all matchs in all 66 books - filter down
  var jmpHTML = [];
  for (i = _sp.iFromBk; i <= _sp.iToBk; i++) {
     jmpHTML[i-_sp.iFromBk] = _sp.jmpHTML[i]; 
  }
  
  var HideShowStrongs = '<p>'
    +'<span class="verseNumberBlue2" onclick="MagicSearchControl(null);" '
    +'style="background-color:#ffeebb;border:1px #eca solid;padding:6px 15px;margin-right:6px;">Controls</span>'
    +'<span class="verseNumberBlue2" onclick="greenLinkClick_simple();" '
    +'style="background-color:#ffeebb;border:1px #eca solid;padding:6px 15px;">Strongs Numbers</span></p>';
  
  _sp.oStatus.innerHTML = "Match verses: " + FormatNum(count)+ "&nbsp;&nbsp;" + jmpHTML.join("");
  if (count) _sp.oTarget.innerHTML = HideShowStrongs + html.join('');     // Use "<xmp></xmp>" to show raw HTML
   
  var str = _metadata.StrongsVisible();
  if (count && !str)
    ShowStrongs(str);  
}

function DoSearchBooks(sp) {  //Load all books befire calling
  _sp = sp;
/*
      _sp.oTarget     : document.getElementById("SearchResults"),
      _sp.oStatus     : document.getElementById("SrchStatusLine"),
      _sp.sText       : text,
      _sp.iFromBk     : 0,  // gen
      _sp.iToBk       : 65, // rev
      _sp.iFromJS     : kjvObj.book[0].jsFileIdx,
      _sp.iToJS       : kjvObj.book[65].jsFileIdx,
      _sp.xExactMatch : document.getElementById("SrchExactMatch").checked,
      _sp.xMatchCase  : document.getElementById("SrchMatchCase").checked,
      _sp.xMatchAll   : document.getElementById("SrchMatchAll").checked 
      
      //returned
      _sp.words -- array of words we are searching for
      _sp.res[].b .c .v  -- Book/Chapter/Verse of all items
      _sp.res[].vstr -- points to version string
      _sp.res[].cFound -- Num hits found in vstr
      _sp.match[]     -- Same as .res[] but just the matches
      _sp.jmpHTML = [];  -- jump table of buttons 
      
      alert([sp.oTarget.innerHTML, sp.oStatus.innerHTML, "\n", sp.sText, 
         "\nBooks", sp.iFromBk, sp.iToBk, "\nJS", sp.iFromJS, sp.iToJS, 
         "\nChBx", sp.xExactMatch, sp.xMatchCase]);
*/
    //LoadAllJSFiles();   // Load all now called when opening search window 1st time
  
    //List of all verses to search
    var b, c, v, i = 0, n, m;
    _sp.res = [];
    for (b = 0; b < kjvObj.book.length; b++) {  // books
      for (c = 0; c < kjvObj.book[b].chapter.length; c++) {  // chapters
        for (v = 0; v < kjvObj.book[b].chapter[c].length; v++) {
          _sp.res[i] = {
            b      : b,
            c      : c,
            v      : v,
            vstr   : kjvObj.book[b].chapter[c][v],  // verse (object) don't change or original changed 
            cFound : 0      // this can be multiple - could be up to 5, if 5 words searching for       
          }
          i++;
        }
      }
    }

   //Do Search
   var filterRE, match;
   _sp.filterRE = [];
   _sp.words = sp.sText.match(/\S+/g);    //same as .split(" "); but handles multiple white space 
   for (n = 0; n < _sp.words.length; n++) {
     
     // /\b(six|five)(?=(\b|[H]\d+?\b|[|]))/g;
     // Starting with a white space boundary char (but not included)
     // Searching for "six" or "five" 
     // ? = ends with (not included in result) 
     // \b whitespace etc. OR H+one or more numbers. ? stop overrun, terminated by whitespce; OR terminated by a | 
     
     
     if (_sp.xExactMatch && _sp.xMatchCase) {
       
       //If a Strongs number Gnnn Hnnn then it may be next to a word -- eg. GodH430  
       // This works in tests = /(\H|\G)\d+\b/g;
       
       var HGnnn = _sp.words[n].match(/(H|G)\d+/g);
       if (HGnnn !== null && HGnnn.length && HGnnn[0].length == _sp.words[n].length) {
         filterRE = new RegExp(_sp.words[n]+'\\b');    // exact + case -- the | as "Gen 1:1|xxxx"
         _sp.filterRE[n] = new RegExp(_sp.words[n]+'\\b', "g");    // exact + case         
       }
       else {       
         filterRE = new RegExp('\\b('+_sp.words[n]+')(?=(\\b|[H]\\d+?\\b|[G]\\d+?\\b|[|]))');    // exact + case -- the | as "Gen 1:1|xxxx"
         _sp.filterRE[n] = new RegExp('\\b('+_sp.words[n]+')(?=(\\b|[H]\\d+?\\b|[G]\\d+?\\b|[|]))', "g");    // exact + case
       }
     }
     else if (_sp.xExactMatch) {
       
       //If a Strongs number Gnnn Hnnn then it may be next to a word -- eg. GodH430  
       // This works in tests = /(\H|\G)\d+\b/g;
       var HGnnn = _sp.words[n].match(/(H|G)\d+/gi);
       if (HGnnn !== null && HGnnn.length && HGnnn[0].length == _sp.words[n].length) {
         filterRE = new RegExp(_sp.words[n]+'\\b', "i");   // exact + ignore case
         _sp.filterRE[n] = new RegExp(_sp.words[n]+'\\b', "gi");   // exact + ignore case
       }
       else {   
         filterRE = new RegExp('\\b('+_sp.words[n]+')(?=(\\b|[H]\\d+?\\b|[G]\\d+?\\b|[|]))', "i");   // exact + ignore case
         _sp.filterRE[n] = new RegExp('\\b('+_sp.words[n]+')(?=(\\b|[H]\\d+?\\b|[G]\\d+?\\b|[|]))', "gi");   // exact + ignore case
       }
     }
     else if (_sp.xMatchCase) {
       filterRE = new RegExp(_sp.words[n]);      // not exact +  case
       _sp.filterRE[n] = new RegExp(_sp.words[n], "g");      // not exact +  case
     }
     else {
       filterRE = new RegExp(_sp.words[n], "i");     // not exact + ignore case
       _sp.filterRE[n] = new RegExp(_sp.words[n], "gi");     // not exact + ignore case
     }
 
     for (i = 0; i < _sp.res.length; i++) 
     {   
        // some verses are a Title + Verse string array 
        if (typeof _sp.res[i].vstr == "object" && _sp.res[i].vstr.length >= 2)
          match = _sp.res[i].vstr.join(" ").search(filterRE);
        else 
          match = _sp.res[i].vstr.search(filterRE);
        if (match >= 0)
          _sp.res[i].cFound++;

     }
   }
    
   //Just the Verse Matches >> Verse Count Match = _sp.match.length
   _sp.match = [];
   _sp.book = [];
   var n = 0, bk = -1, match;
   for (i = 0; i < _sp.res.length; i++) {
     //Build Book array
     if (_sp.res[i].b !== bk) {
       bk = _sp.res[i].b;
       _sp.book[bk] = {
         found  : 0,      // matching verse count in book 
         bcvStr : ""
       }
     }
     
     //Build Match array
     match = false;
     if (_sp.xMatchAll) {
       if (_sp.res[i].cFound === _sp.words.length)   // all words match
          match = true;
     }
     else if (_sp.res[i].cFound) {
       match = true;
     }
     
     if (match) {
        _sp.match[n] = _sp.res[i];  // dup Obj only
        n++;
       
        _sp.book[bk].found++;
        if (_sp.book[bk].found == 1) //remember ID of first book match
          _sp.book[bk].bcvStr = MakeSrchBVC(_sp.res[i].b, _sp.res[i].c, _sp.res[i].v); 
     }
   } 

  
   // JumpTable HTML = size 66 - same as books[] 
   _sp.jmpHTML = [];
   for (i = 0; i < _sp.book.length; i++) 
   {
     if (_sp.book[i].found)  {
       var id = _sp.book[i].bcvStr;
       _sp.jmpHTML.push('<span onclick="JumpToSearchBCV(\''+id+'\')" class="srchJumpBtn">'+ kjvObj.book[i].name3 + '('+_sp.book[i].found+')' +'</span>');
     } 
     else _sp.jmpHTML.push('');    
   }
      
   DoSearch_ShowResults();
   EndBlueSearch();          //tell caller "done" (as may be called on timer delay) 
}

//============ Display Data
/*
var html = [];
html.push(
  "<html>",
  "<body>",
  "bla bla bla",
  "</body>",
  "</html>"
);
return html.join("");

var fruits = ["Banana", "Orange", "Apple", "Mango"];
var energy = fruits.join(" and ");

var hege = ["Cecilie", "Lone"];
var stale = ["Emil", "Tobias", "Linus"];
var kai = ["Robin"];
return = hege.concat(stale, kai);

var fruits = ["Banana", "Orange", "Apple", "Mango"];
fruits.push("Kiwi");

array.push(item1, item2, ..., itemX)
*/

function ChapterVerses(bkIdx, chapter) { 
  if (bkIdx >= 0) return kjvObj.book[bkIdx].verses(chapter); else return 0;
}
function CV_IsLastVerses(bkIdx, chapter, verse) { //check if verse near end of list (so we don't scroll adjust)
  return ((kjvObj.book[bkIdx].chapters == chapter)
       && (kjvObj.book[bkIdx].chapter[chapter-1].length <= verse+4)); 
}
function MakeCHID(chapter) {
  return "chID_"+chapter;  //eg. chID_n
}
function MakeCVID(bkIdx, chapter, verse) {
  return "cvID_"+bkIdx+"_"+chapter+"_"+verse;  //eg. cvID_0_1_1
}
function CV_ScrollTo(bk, sticky_height, idOverride) {  //scroll to selected C:V
  var sID;
  var ChHdr = _metadata.settings[_md.ChHdr].checked;
  if (ChHdr && bk.verse < 6)           // include book title if we can
     sID = MakeCHID(bk.chapter);
  else {
     if (idOverride !== "")
       sID = idOverride
     else 
       sID = MakeCVID(bk.index, bk.chapter, bk.verse);
  }
  var el = document.getElementById(sID);
  if (el) {
    el.scrollIntoView();

    if (bk.chapter == 1 && bk.verse < 6) {
      document.body.scrollTop = sticky_height;
      document.documentElement.scrollTop = sticky_height;
    }
    else {
      if (!CV_IsLastVerses(bk.index, bk.chapter, bk.verse)) 
      {
        document.body.scrollTop += -sticky_height; //134 safari
        document.documentElement.scrollTop += -sticky_height; //other browsers
      }
    }

  } //else alert("ID not found :"+sID);
} 
function BibleVerseSubs(str) { 
  //Underline LORD, GOD, God 410
  var str = str.replace(/[L][O][R][D]\W?[H]\d\d*/g, 
    function(x) {return '<span style="color:red;border-bottom:2px dashed #fdd">'+x.substr(0,4)+'</span>'+x.substr(4);});  
  var str = str.replace(/[G][O][D]\W?[H]\d\d*/g, 
    function(x) {return '<span style="color:red;border-bottom:2px dashed #fdd">'+x.substr(0,3)+'</span>'+x.substr(3);});  
  var str = str.replace(/[G][o][d]\W?[H][4][1][0]/gi, 
    function(x) {return '<span style="color:red;border-bottom:2px dashed #fdd">'+x.substr(0,3)+'</span>'+x.substr(3);});  
 
  //may have 0 or 1 non-word char inbetween God and H430
  //var str = str.replace(/god(s?)\W?[H][4][3][0]/gi, 
  var str = str.replace(/\w+\W?[H][4][3][0]\b/gi,
    function (x) {
      var p = x.search(/\W?[H]\d+/);
      if (p <= 0) return x;   // can match "H4136 H430"
      return '<span style="color:blue;border-bottom:2px dashed #ddf;">'+x.substr(0,p)+'(elohim)</span>'+x.substr(p);
  });
  return str;
}

//Moved to Tools.html
//function ShowStrongNum(el) {
//   alert("show Strong Number Info = "+el.innerHTML);
//}

var _curBkIdx = -1;
function StyleAllStrongNums(str) { 
  // Deal with Backets (H2000) and (H2000 H300)
  // Since brakets need to be small subscript text === but not part of Hnnn hyperlink
  var str = str.replace(/[(][H]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup">(</span>'+Hnn.substr(1, Hnn.length-1);
  });
  var str = str.replace(/[H]\d\d*[)]/g, function (Hnn) {
    return Hnn.substr(0, Hnn.length-1)+'<span class="myStrongsSup">)</span>';
  });
  
  var str = str.replace(/[(][G]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup">(</span>'+Hnn.substr(1, Hnn.length-1);
  });
  var str = str.replace(/[G]\d\d*[)]/g, function (Hnn) {
    return Hnn.substr(0, Hnn.length-1)+'<span class="myStrongsSup">)</span>';
  });

  // Now we can deal with Hnnn or Gnnn Link 
  var str = str.replace(/[H]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup" onclick="ShowStrongNum(this);">'+Hnn+'</span>';
  });
  var str = str.replace(/[G]\d\d*/g, function (Hnn) {
    return '<span class="myStrongsSup" onclick="ShowStrongNum(this);">'+Hnn+'</span>';
  });
  return str;
}
function ShowStrongs(fValue) {
  var i, elements = document.getElementsByClassName("myStrongsSup");
  for (var i = 0; i < elements.length; i++){
    if (fValue) elements[i].style.display = "inline-block";
    else elements[i].style.display = "none";
  } 
}
function greenLinkClick_simple() {
    var str = !_metadata.strongs;
    _metadata.StrongsVisible(str);  // save state
    //showHide
    ShowStrongs(str);
}
function greenLinkClick(el, cvStr) {
    // Toggle current & store
    var str = !_metadata.strongs;
    _metadata.StrongsVisible(str);  // save state
  
    //showHide - keeping scroll position
    var elPos = el.getBoundingClientRect().top;
    ShowStrongs(str);
    var elOffset = elPos - el.getBoundingClientRect().top;
    window.scrollBy(0, -elOffset); 
  
    //Update cc:vv display and _currentBook
    var ss = cvStr.split(/\D+/);  // "Gen 1:22" -> ",1,22"
    if (ss.length === 3) {
      //alert(parseInt(ss[1]) +","+ parseInt(ss[2])); //rwc1111
      var actCh = parseInt(ss[1]) - kjvObj.book[_curBkIdx].vOffset; //eg. AoP Displays 33-nn chap (stored as 1-m)
      UpdateChVsDisplay(actCh, parseInt(ss[2]));
    }
}
function FormatVerse(html, str, newPara, brLineIndent) {
   // Markup showing?
   if (_metadata.settings[_md.Markup].checked)
     var str = BibleVerseSubs(str); 
  
   var n = str.indexOf("|");          // "Gen 1:2|verse text..."
  
   var cvStr = str.substr(0, n);  // just "Gen 1:2"
   if (brLineIndent) {

      html.push('<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberIndentSup">' ,
                  cvStr.split(":")[1], // "2 of Gen 1:2"
               '</span>&nbsp;');      
   }
   else {
     if (newPara)
       html.push('<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberGreen">' ,
                  cvStr, // "Gen 1:2"
               '</span>&nbsp;&nbsp;');  
     else
        html.push('&nbsp;<span onclick="greenLinkClick(this,\''+cvStr+'\');" class="verseNumberSup">' ,
                  cvStr.split(":")[1], // "2 of Gen 1:2"
               '</span>'); 
   }
  
   // Verse Text
   html.push(StyleAllStrongNums(str.substr(n+1)));
}
function HideShowCh(book_chapter_ID) {
   var el = document.getElementById(book_chapter_ID);
   //alert(el);
   if (el.style.display == "none") 
     el.style.display = "block"; else el.style.display = "none"; 
}
function ExpandContractChapters(event) { 
  event.stopPropagation();
  event.stopImmediatePropagation();
  
  // get scroll pos of Chapter
  var elPos = event.target.getBoundingClientRect().top;
  
  // first loop sniffs if any closed
  var i, eClose=false, elements = document.getElementsByClassName("ChapterContentDiv");
  for (var i = 0; i < elements.length; i++){
    if (elements[i].style.display === "none") {   
      eClose = true;
      break;
    }
  }  
  // Toggle ALL to the oposite state
  for (var i = 0; i < elements.length; i++){
    if (eClose) elements[i].style.display = "block";
    else elements[i].style.display = "none";
  } 
  
  //restore scroll position
  var elOffset = elPos - event.target.getBoundingClientRect().top;
  window.scrollBy(0, -elOffset);
}
function PlayAudio(event) { //rwc1
  event.stopPropagation();
  event.stopImmediatePropagation();
  var elDiv = event.target.parentElement;
  if (elDiv) {
    // Parent DIV as attribute ID = chID_n
    var ch = parseInt(elDiv.getAttribute("id").split("_")[1]);
    //same book/ch? Then just show the window
    kjvObj.book[_curBkIdx].Audio(ch);
  }
}
function DoMarkVerse(b,c,v) {
  //highlight target
  var cvID = MakeCVID(b, c, v);
  var verseSpan = document.getElementById(cvID);
  if (verseSpan !== null && typeof verseSpan === "object") {
    verseSpan.style.backgroundColor = "#ffeebb";
  } 
}
function DelayMarkVerse(b,c,v) {
  window.setTimeout( function(){ DoMarkVerse(b,c,v); }, 700);
}
function DelayMarkVerse1(bk) {
  DelayMarkVerse(bk.index,bk.chapter,bk.verse);
}
function FormatBibleText(bk, div) {
  var ChHdr = _metadata.settings[_md.ChHdr].checked;         // Show Ch Headings -- and thus Expando
  var TopicHdr = _metadata.settings[_md.TopicHdr].checked;   // Show Topic Headings (embedded in verse)
  
  var html = [''];
  var i, n, cvID, chID;
  var insideP = false;

  var bkIdx = bk.index;
  _curBkIdx = bk.index;
  
  var verseObj = [], sVerse, sTopic = "";              // most verses are single string -- some are str array Obj [topicHdr, Verse]
  var redInfo = null;  //null of array
  var ppar = null, ppOK = false, newPara, brLineIndent = false, vsTotal;
  var debugMode = _metadata.debugMode;

  //Get global from store
  var strongs = _metadata.StrongsVisible(); 
        
  // == Chapters ==
  for (i = 0; i < kjvObj.book[bkIdx].chapter.length; i++) {
    
    // Chapter Heading -- Clickable -- 🎧127911	1F3A7
    if (ChHdr) {
      chID = MakeCHID(i+1); // chID_n
      var chNum = kjvObj.book[bkIdx].vOffset + i + 1;
      html.push('<div id="'+chID+'" class="ChapterTitle" onclick="HideShowCh(\'book_chapter_'+i+'\');">' 
              +bk.book+ ' ❭ '+chNum //(i+1)
              +'<span title="Expand All" class="ChapterTitleIcon" onclick="ExpandContractChapters(event);">+</span>'
              +'<span title="Play Audio" class="ChapterTitleAudioIcon" onclick="PlayAudio(event);">☊</span></div>');   // @ &#127911;      
    }
     
    // if current chapt OE Expand is OFF --> Show Block
    if (i == bk.chapter-1 || !ChHdr) 
      html.push('<div id="book_chapter_'+i+'" class="ChapterContentDiv">');
    else 
      html.push('<div id="book_chapter_'+i+'" class="ChapterContentDiv" style="display:none;">');

    // Chapter paragraphs ON?
    vsTotal = kjvObj.book[bkIdx].chapter[i].length;
    if (_metadata.settings[_md.ParaOn].checked) {
      //if (i==48)alert("ready");
      ppar = SeedToParaArray(bkIdx, i, vsTotal);
      //if (i==48) alert([ppOK,"\n",ppar.par,"\n",ppar.start]);
      ppOK = (ppar !== null && ppar.par.length == vsTotal && ppar.start.length == vsTotal && ppar.end.length == vsTotal);
      //if (i==48)alert(ppOK);
      debugMode = false; //!ppOK;  //rwc
      brLineIndent = false;
    }
    
    // == Verses ==
    for (n = 0; n < vsTotal; n++) {
      cvID = MakeCVID(bkIdx, i+1, n+1);
      verseObj = kjvObj.book[bkIdx].chapter[i][n];
      
      // Verse obj ["TopicHrd", VerseStr] OR "VerseStr"
      if (typeof verseObj == "object" && verseObj.length >= 2) 
           { sVerse = verseObj[1]; if (TopicHdr) sTopic = verseObj[0]; }  // if topic Hdr enabled then extract
      else { sVerse = verseObj;    sTopic = ""; }
      
      
      // debug
      if (debugMode && n==0) {
        html.push('<div style="font-family:\'Courier New\',monospace;padding:12px;background-color:#655;color:white;font-size:14px;overflow:auto;">');  
        html.push('Debug: ch='+(i+1)+', vs='+(n+1)+', seed=['+_paragraphs[bkIdx][i]+']'); 
        if (ppar !== null){
          html.push('<br>ppar.par=['+ppar.par+']'); 
          html.push('<br>ppar.sta=['+ppar.start+']');
          html.push('<br>ppar.end=['+ppar.end+']');
        }
        html.push('</div>');
      }
      
      //write Study note? or Topic Header?
      //
      var note = _study.GetNote(bkIdx,i+1,n+1);
      if (note.length || sTopic.length) 
      {
         //temporarily close <p> paragraph wrapper, to show Notes / or Topic Header
         if (insideP) html.push('</p>');
        
         //topic header
         if (sTopic.length)
           html.push('<div style="margin-top:19px;margin-bottom:12px;padding:6px 8px; font-size:100%;font-weight:bold;color:#222;background-color:lightgreen;">' 
              +sTopic+ '</div>');    
        
         //sudy note
         if (note.length)
           html.push(note.join(" ")); 
        
         //reopen paragraph <p> wrapper
         if (insideP) html.push('<p style="line-height:140%;margin: 14px 0px;">'); //border:1px green solid;
      }
      
      // new paragraph wrap
      newPara = (!ppOK || ppar.start[n]);
      if (newPara) {  
        //new paragraph wrap
        insideP = true;
        html.push('<p style="line-height:140%;margin: 14px 0px;">');  //new paragraph wrap -- border:1px red solid;
        brLineIndent = (ppOK && ppar.start[n] && ppar.par[n] <= -1);  //-num line break codes
      }

      // first Paragraph of chapter -- if breif break mode, write for header "bk ch:vs"
      if (n == 0 && newPara && brLineIndent)
      {
         html.push('<div class="verseNumberGreen2" onclick="greenLinkClick(this,\''+sVerse.split("|")[0]+'\');">',
                  sVerse.split("|")[0], // "Gen 1:2"
                  '</div>');
      }
      
      // Verse wrap
      if (brLineIndent)
        html.push('<span id="'+cvID+'" style="margin-left:44px;display:block;text-indent: -16px;">'); 
      else 
        html.push('<span id="'+cvID+'">');       //verse text wrap 
      
      // Verse String
      FormatVerse(html, sVerse, newPara, brLineIndent);   
      
      html.push('</span>');        //end verse text wrap 
      if (!ppOK || ppar.end[n]) {  //end verse para wrap
        html.push('</p>'); 
        insideP = false;
      }
    }
    html.push('</div>');
  }
  html.push('<br>');
  div.innerHTML = html.join('');
  
  if (!_metadata.strongs)
    ShowStrongs(false);
  
  if (bkIdx == 66) {
    //always mark the main AoP verse
    DoMarkVerse(bkIdx,6,5);
  }
}







